SEGMENT code USE32


..start 
	GLOBAL _DllMain		;Just a small routine that gets called.
	EXPORT _DllMain
_DllMain:	mov	eax, 1  ;Dont worry about this.
		retn	12	;


;Private Declare Function rollcrc Lib "selectbackup.dll"
;  (ByRef CurrentCRC As Long, ByRef BufferSize As Long, ByRef LeadingByte As Any, ByRef TrailingByte As Any, ByRef HashTable as any, ByRef TableSize as long) As Long

	GLOBAL _rollcrc@24
	EXPORT _rollcrc@24
_rollcrc@24:
	enter	0, 0		;set up ebp for arguments
	push edi		;Preserve edi, ebx and esi
	push ebx
	push esi
	

	mov	ebx, [ebp+12]	;pointer to BufferSize
	mov	ecx, [ebx]	;counter set to value of BufferSize
	mov	ebx, [ebp+8]	;pointer to CurrentCRC
	mov	eax, [ebx]	;value of CurrentCRC

	mov	esi, [ebp+16]	;pointer to LeadingByte
	mov	edi, [ebp+20]	;pointer to TrailingByte

loop_start:

	mov	edx, [esi]
	movzx	edx, dl	
	add	eax, edx	;add leading byte

	mov	edx, [edi]
	movzx	edx, dl
	sub	eax, edx	;subtract trailing byte

	push	ecx		;borrow ecx for second loop
	mov	ebx, [ebp+28]	;pointer to table size.
	mov	ecx, [ebx]
	
	push	esi
	mov	esi, [ebp+24]	;pointer to hash table

hash_loop:

	cmp	eax, [esi]	;compare with current checksum
	je	hash_found	;match found, exit loop
	add	esi, 4		;advance hash table pointer 4 bytes
	loop	hash_loop

	pop 	esi
	pop	ecx		;okay. back to outer loop.

	inc	esi		;increment leading pointer
	inc	edi		;increment trailing pointer

	loop	loop_start	;loop until ecx (BufferSize) = 0

	jmp	hash_not_found

hash_found:
	mov	ebx, [ebp+28]	;pointer to table size. Used to return hash index
	mov	edx, [ebx]
	sub	edx, ecx	;hash index = TableSize - counter
	mov	[ebx], edx	;replace TableSize with hash index

	pop	esi
	pop	ecx

	mov	ebx, [ebp+12]	;pointer to BufferSize. Used to return buffer index
	mov	edx, [ebx]	;save value of BufferSize
	sub	edx, ecx	;buffer index = BufferSize - counter
	mov	[ebx], edx

	mov	ebx, [ebp+8]	;pointer to CurrentCRC.
	mov	[ebx], eax	;update checksum

	xor	eax, eax
	add	eax, 1		;return 1 if found
	jmp	done

hash_not_found:
	mov	ebx, [ebp+8]	;pointer to CurrentCRC.
	mov	[ebx], eax	;update checksum
	xor	eax, eax	;return 0 if not found

done:

	pop	esi
	pop	ebx
	pop	edi
	
	leave
	retn 24			;return, with 24 bytes of arguments (6 DWords)

	ENDS
